<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPromptMessage ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPromptMessage
 * @subpackage Arrays
 */
class ArrayOfPromptMessage extends AbstractStructArrayBase
{
    /**
     * The PromptMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\PromptMessage[]
     */
    public $PromptMessage;
    /**
     * Constructor method for ArrayOfPromptMessage
     * @uses ArrayOfPromptMessage::setPromptMessage()
     * @param \patest\StructType\PromptMessage[] $promptMessage
     */
    public function __construct(array $promptMessage = array())
    {
        $this
            ->setPromptMessage($promptMessage);
    }
    /**
     * Get PromptMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\PromptMessage[]|null
     */
    public function getPromptMessage()
    {
        return isset($this->PromptMessage) ? $this->PromptMessage : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPromptMessage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPromptMessage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePromptMessageForArrayConstraintsFromSetPromptMessage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPromptMessagePromptMessageItem) {
            // validation for constraint: itemType
            if (!$arrayOfPromptMessagePromptMessageItem instanceof \patest\StructType\PromptMessage) {
                $invalidValues[] = is_object($arrayOfPromptMessagePromptMessageItem) ? get_class($arrayOfPromptMessagePromptMessageItem) : sprintf('%s(%s)', gettype($arrayOfPromptMessagePromptMessageItem), var_export($arrayOfPromptMessagePromptMessageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PromptMessage property can only contain items of type \patest\StructType\PromptMessage, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PromptMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PromptMessage[] $promptMessage
     * @return \patest\ArrayType\ArrayOfPromptMessage
     */
    public function setPromptMessage(array $promptMessage = array())
    {
        // validation for constraint: array
        if ('' !== ($promptMessageArrayErrorMessage = self::validatePromptMessageForArrayConstraintsFromSetPromptMessage($promptMessage))) {
            throw new \InvalidArgumentException($promptMessageArrayErrorMessage, __LINE__);
        }
        if (is_null($promptMessage) || (is_array($promptMessage) && empty($promptMessage))) {
            unset($this->PromptMessage);
        } else {
            $this->PromptMessage = $promptMessage;
        }
        return $this;
    }
    /**
     * Add item to PromptMessage value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\PromptMessage $item
     * @return \patest\ArrayType\ArrayOfPromptMessage
     */
    public function addToPromptMessage(\patest\StructType\PromptMessage $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\PromptMessage) {
            throw new \InvalidArgumentException(sprintf('The PromptMessage property can only contain items of type \patest\StructType\PromptMessage, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PromptMessage[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\PromptMessage|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\PromptMessage|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\PromptMessage|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\PromptMessage|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\PromptMessage|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PromptMessage
     */
    public function getAttributeName()
    {
        return 'PromptMessage';
    }
}
